{ 021109e3.pas                                                              }
{ 2002-11-09 programmeerimisvistluse edasijudnute 3. lesande lahendus    }
{    REIS MBER SAARE                                                       }
{ Konstantin Tretjakov                                                      }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

{ Both problem and solution (c) 2002 Konstantin Tretyakov                   }

type
    Coords = record
        X,Y: Byte;
    end;

const
    MAX_MAP = 50;
var
   Data: array[0..MAX_MAP+1, 0..MAX_MAP+1] of Integer;
   WhereFrom: array[1..MAX_MAP, 1..MAX_MAP] of Byte;

   FI, FO: Text;
   R,C,i,j, TripLen: Integer;
   ch: Char;
   Boat: Coords;
   TopLand, BottomLand, ChosenPoint1, ChosenPoint2: Coords;

   S :array[1..MAX_MAP*MAX_MAP] of Coords;    {   Queue   }
   HP, TP: Integer;
   u: String;
const
   D_LAND = 30000;
   D_SEA = 29999;
   D_TRIP = 29998;
   D_BOAT = 29997;
   W_HERE = 0;
   W_N=1;
   W_NE=2;
   W_E=3;
   W_SE=4;
   W_S=5;
   W_SW=6;
   W_W=7;
   W_NW=8;


procedure PushC(X, Y :Byte; D:Integer; WF:Byte);
begin
    Inc(HP);
    if HP > MAX_MAP*MAX_MAP then HP := 1;
    S[HP].X := X;
    S[HP].Y := Y;
    if Data[X, Y] < 0 then Data[X,Y] := -D
        else Data[X, Y] := D;
	WhereFrom[X,Y] := WF;
end;


procedure Pop(var A:Coords);
begin
    inc(TP);
    if TP > MAX_MAP*MAX_MAP then TP := 1;
	A := S[TP];
end;

procedure DoFill;
var A: Coords; D: Integer;
begin
{   Initialize queue    }
    HP := 0;
    TP := 0;
    PushC(Boat.X, Boat.Y, 0, W_HERE);
    while (HP > TP) do begin    {   While queue not empty   }
        Pop(A);
        D := Abs(Data[A.X, A.Y]) + 1;
        if Abs(Data[A.X + 1, A.Y]) = D_SEA then PushC(A.X + 1, A.Y, D, W_N);
        if Abs(Data[A.X - 1, A.Y]) = D_SEA then PushC(A.X - 1, A.Y, D, W_S);
        if Data[A.X, A.Y - 1] = D_SEA then PushC(A.X, A.Y - 1, D, W_E);
        if Data[A.X + 1, A.Y - 1] = D_SEA then PushC(A.X + 1, A.Y - 1, D, W_NE);
        if Data[A.X - 1, A.Y - 1] = D_SEA then PushC(A.X - 1, A.Y - 1, D, W_SE);
        if Data[A.X, A.Y] >= 0 then begin
            if Abs(Data[A.X, A.Y + 1]) = D_SEA then PushC(A.X, A.Y + 1, D, W_W);
            if Abs(Data[A.X - 1, A.Y + 1]) = D_SEA then PushC(A.X - 1, A.Y + 1, D, W_SW);
            if Abs(Data[A.X + 1, A.Y + 1]) = D_SEA then PushC(A.X + 1, A.Y + 1, D, W_NW);
        end;
    end;
end;


procedure MarkTrip(Start :Coords);
var D:Byte;
begin
    repeat
        D := WhereFrom[Start.X, Start.Y];
        Data[Start.X, Start.Y] := D_TRIP;
        case D of
        W_N: Dec(Start.X);
        W_NE: begin
            Dec(Start.X);
			Inc(Start.Y);
            end;
        W_E: Inc(Start.Y);
        W_SE: begin
      	    Inc(Start.Y);
            Inc(Start.X);
        end;
        W_S: Inc(Start.X);
        W_SW: begin
      	    Inc(Start.X);
            Dec(Start.Y);
        end;
        W_W: Dec(Start.Y);
        W_NW: begin
            Dec(Start.Y);
            Dec(Start.X);
        end;
        end;
    until D = W_HERE;
end;



begin
    Assign(FI, 'saar.sis');
    Assign(FO, 'saar.val');
    Reset(FI); Rewrite(FO);
	ReadLn(FI, R, C);

{   Load data into Data array   }
    for i:=1 to R do begin
        for j:=1 to C do begin
            Read(FI, ch);
            if (ch='X') then begin
                BottomLand.X := i;
                BottomLand.Y := j;
                if TopLand.X = 0 then begin
                    TopLand.X := i;
                    TopLand.Y := j;
                end;
            end;
            if ch = '*' then begin
                Boat.X := i;
                Boat.Y := j;
                ch := '.';
            end;
            if ch='.' then Data[i, j] := D_SEA else Data[i, j] := D_LAND;
        end;
        ReadLn(FI);
    end;

{   Add "borders" to map    }
    for i := 0 to R+1 do begin
        Data[i, 0] := D_LAND;
        Data[i, C+1] := D_LAND;
    end;
    for j := 0 to C+1 do begin
        Data[0, j] := D_LAND;
        Data[R+1, j] := D_LAND;
    end;

{   Decide, where to put the fictious "border"  }
    if Boat.X < TopLand.X then begin
    {   The border will go from the bottom of the map to the lowermost point    }
        ChosenPoint1.X := BottomLand.X + 1;
        ChosenPoint1.Y := BottomLand.Y;
        ChosenPoint2.X := BottomLand.X;
        ChosenPoint2.Y := BottomLand.Y + 1;
        for i := BottomLand.X + 1 to R do Data[i, BottomLand.Y] := -D_SEA;
        if Data[ChosenPoint2.X, ChosenPoint2.Y] = D_LAND then Inc(ChosenPoint2.X);
    end else begin
    {   The border will go from the top of the map to the island's topmost point    }
        ChosenPoint1.X := TopLand.X - 1;
        ChosenPoint1.Y := TopLand.Y;
        ChosenPoint2.X := TopLand.X;
        ChosenPoint2.Y := TopLand.Y + 1;
        for i := TopLand.X - 1 downto 1 do Data[i, TopLand.Y] := -D_SEA;
        if Data[ChosenPoint2.X, ChosenPoint2.Y] = D_LAND then Dec(ChosenPoint2.X);
    end;
{   Find distances to ChosenPoint1 and ChosenPoint2 taking the "border" into account    }
    DoFill;

{   Trip length is the sum of distances to these points + 1 }
    TripLen := -Data[ChosenPoint1.X, ChosenPoint1.Y] + Data[ChosenPoint2.X, ChosenPoint2.Y] + 1;

{   Mark the trip on map    }
    MarkTrip(ChosenPoint1);
    MarkTrip(ChosenPoint2);
    Data[Boat.X, Boat.Y] := D_BOAT;

{   Output  }
    WriteLn(FO, TripLen);
    for i:=1 to R do begin
        for j:=1 to C do
			if Data[i,j]=D_LAND then Write(FO, 'X')
			else if Data[i,j]=D_TRIP then Write(FO, '+')
            else if Data[i,j]=D_BOAT then Write(FO, '*')
            else Write(FO, '.');
        WriteLn(FO);
    end;

	Close(FI);
	Close(FO);
end.
